diff --git a/src/main/java/net/minecraft/core/net/command/servercommands/SaveCommand.java b/src/main/java/net/minecraft/core/net/command/servercommands/SaveCommand.java
new file mode 100644
index 000000000..2d95ff2b8
--- /dev/null
+++ b/src/main/java/net/minecraft/core/net/command/servercommands/SaveCommand.java
@@ -0,0 +1,91 @@
+package net.minecraft.core.net.command.servercommands;
+
+import net.minecraft.core.net.command.CommandHandler;
+import net.minecraft.core.net.command.CommandSender;
+import net.minecraft.core.net.command.ServerCommand;
+import net.minecraft.server.MinecraftServer;
+import net.minecraft.server.world.WorldServer;
+
+public class SaveCommand extends ServerCommand {
+    public SaveCommand(MinecraftServer server) {
+        super(server, "save");
+    }
+
+    @Override
+    public boolean execute(CommandHandler handler, CommandSender sender, String[] args) {
+        String senderName = sender.getName();
+        if(args.length < 1)
+        {
+            return false;
+        }
+        String subCommand = args[0].toLowerCase();
+
+        switch (subCommand){
+            case "all":
+                sendNoticeToOps(senderName, "Forcing save..");
+                if(server.playerList != null) {
+                    server.playerList.savePlayerStates();
+                }
+                for(int i = 0; i < server.dimensionWorlds.length; i++) {
+                    WorldServer worldserver = server.dimensionWorlds[i];
+                    worldserver.saveWorld(true, null, i == 0);
+                }
+
+                sendNoticeToOps(senderName, "Save complete.");
+                return true;
+            case "on":
+                sendNoticeToOps(senderName, "Enabling level saving..");
+                for(int k = 0; k < server.dimensionWorlds.length; k++)
+                {
+                    WorldServer worldserver2 = server.dimensionWorlds[k];
+                    worldserver2.levelSaving = false;
+                }
+                return true;
+            case "off":
+                sendNoticeToOps(senderName, "Disabling level saving..");
+                for(int j = 0; j < server.dimensionWorlds.length; j++)
+                {
+                    WorldServer worldserver1 = server.dimensionWorlds[j];
+                    worldserver1.levelSaving = true;
+                }
+                return true;
+            case "interval":
+                if (args.length < 2) {
+                    sender.sendMessage("Current save interval is " + server.propertyManager.getIntProperty("autosaveInterval", server.autoSaveInterval));
+                    return true;
+                }
+                int interval = Integer.parseInt(args[1]);
+                server.propertyManager.setProperty("autosaveInterval", interval);
+                server.autoSaveInterval = interval;
+                sendNoticeToOps(senderName, "Setting save interval to " + interval);
+                return true;
+            case "amount":
+                if (args.length < 2) {
+                    sender.sendMessage("Current chunks saved per autosave is " + server.propertyManager.getIntProperty("maxChunksSavedPerAutosave", server.chunksSavedPerAutosave));
+                    return true;
+                }
+                int amount = Integer.parseInt(args[1]);
+                server.propertyManager.setProperty("maxChunksSavedPerAutosave", amount);
+                server.chunksSavedPerAutosave = amount;
+                sendNoticeToOps(senderName, "Setting max chunks saved to " + amount);
+                return true;
+        }
+        return false;
+    }
+
+    @Override
+    public boolean opRequired(String[] args) {
+        return true;
+    }
+
+    @Override
+    public void sendCommandSyntax(CommandHandler handler, CommandSender sender) {
+        sender.sendMessage("/save on");
+        sender.sendMessage("/save off");
+        sender.sendMessage("/save all");
+        sender.sendMessage("/save interval");
+        sender.sendMessage("/save interval <seconds>");
+        sender.sendMessage("/save amount");
+        sender.sendMessage("/save amount <chunks>");
+    }
+}
diff --git a/src/main/java/net/minecraft/core/net/command/servercommands/SayCommand.java b/src/main/java/net/minecraft/core/net/command/servercommands/SayCommand.java
new file mode 100644
index 000000000..92ad1a49b
--- /dev/null
+++ b/src/main/java/net/minecraft/core/net/command/servercommands/SayCommand.java
@@ -0,0 +1,42 @@
+package net.minecraft.core.net.command.servercommands;
+
+import net.minecraft.core.net.command.CommandHandler;
+import net.minecraft.core.net.command.CommandSender;
+import net.minecraft.core.net.command.ServerCommand;
+import net.minecraft.core.net.command.TextFormatting;
+import net.minecraft.core.net.packet.ChatPacket;
+import net.minecraft.server.MinecraftServer;
+
+public class SayCommand extends ServerCommand {
+    public SayCommand(MinecraftServer server) {
+        super(server, "say");
+    }
+
+    @Override
+    public boolean execute(CommandHandler handler, CommandSender sender, String[] args) {
+        if (args.length < 1) return false;
+
+        String senderName = sender.getName();
+
+        StringBuilder messageBuilder = new StringBuilder();
+        for (String arg : args){
+            messageBuilder.append(arg).append(" ");
+        }
+        String message = messageBuilder.toString().trim();
+
+        MinecraftServer.logger.info("[" + senderName + "] " + message);
+        server.playerList.sendPacketToAllPlayers(new ChatPacket(TextFormatting.PINK + "[Server] " + message));
+
+        return true;
+    }
+
+    @Override
+    public boolean opRequired(String[] args) {
+        return true;
+    }
+
+    @Override
+    public void sendCommandSyntax(CommandHandler handler, CommandSender sender) {
+        sender.sendMessage("/say <message>");
+    }
+}
diff --git a/src/main/java/net/minecraft/core/net/command/commands/ScoreCommand.java b/src/main/java/net/minecraft/core/net/command/servercommands/ScoreCommand.java
similarity index 76%
rename from src/main/java/net/minecraft/core/net/command/commands/ScoreCommand.java
rename to src/main/java/net/minecraft/core/net/command/servercommands/ScoreCommand.java
index 5ced7d023..29f7c88a4 100644
--- a/src/main/java/net/minecraft/core/net/command/commands/ScoreCommand.java
+++ b/src/main/java/net/minecraft/core/net/command/servercommands/ScoreCommand.java
@@ -1,8 +1,8 @@
-package net.minecraft.core.net.command.commands;
+package net.minecraft.core.net.command.servercommands;
 
 import net.minecraft.server.MinecraftServer;
-import net.minecraft.server.entity.player.EntityPlayerMP;
-import net.minecraft.core.net.packet.Packet72UpdatePlayerProfile;
+import net.minecraft.server.entity.player.ServerPlayer;
+import net.minecraft.core.net.packet.UpdatePlayerProfilePacket;
 import net.minecraft.core.net.command.TextFormatting;
 import net.minecraft.core.net.command.CommandHandler;
 import net.minecraft.core.net.command.CommandSender;
@@ -19,7 +19,7 @@ public class ScoreCommand extends ServerCommand
     public boolean execute(CommandHandler handler, CommandSender sender, String[] args) {
         if (args.length < 2) return false;
 
-        EntityPlayerMP player = (EntityPlayerMP)handler.getPlayer(args[0]);
+        ServerPlayer player = (ServerPlayer)handler.getPlayer(args[0]);
         if (player == null) return false;
 
         if (args[1].equalsIgnoreCase("set"))
@@ -29,7 +29,7 @@ public class ScoreCommand extends ServerCommand
             int newScore = Integer.parseInt(args[2]);
 
             player.score = newScore;
-            server.playerList.sendPacketToAllPlayers(new Packet72UpdatePlayerProfile(player.username, player.nickname, player.score, player.chatColor, true, player.isOperator()));
+            server.playerList.sendPacketToAllPlayers(new UpdatePlayerProfilePacket(player.username, player.nickname, player.score, player.chatColor, true, player.isOperator()));
             sender.sendMessage("Set " + player.getDisplayName() + TextFormatting.WHITE + "'s score to " + player.score);
             handler.sendMessageToPlayer(player, "Your score was set to " + player.score);
             return true;
@@ -42,7 +42,7 @@ public class ScoreCommand extends ServerCommand
         if (args[1].equalsIgnoreCase("reset"))
         {
             player.score = 0;
-            server.playerList.sendPacketToAllPlayers(new Packet72UpdatePlayerProfile(player.username, player.nickname, player.score, player.chatColor, true, player.isOperator()));
+            server.playerList.sendPacketToAllPlayers(new UpdatePlayerProfilePacket(player.username, player.nickname, player.score, player.chatColor, true, player.isOperator()));
             sender.sendMessage("Set " + player.getDisplayName() + TextFormatting.WHITE + "'s score to " + player.score);
             handler.sendMessageToPlayer(player, "Your score was set to " + player.score);
             return true;
diff --git a/src/main/java/net/minecraft/core/net/command/servercommands/ScoreboardCommand.java b/src/main/java/net/minecraft/core/net/command/servercommands/ScoreboardCommand.java
new file mode 100644
index 000000000..12fdc4110
--- /dev/null
+++ b/src/main/java/net/minecraft/core/net/command/servercommands/ScoreboardCommand.java
@@ -0,0 +1,47 @@
+package net.minecraft.core.net.command.servercommands;
+
+import net.minecraft.core.net.command.CommandHandler;
+import net.minecraft.core.net.command.CommandSender;
+import net.minecraft.core.net.command.ServerCommand;
+import net.minecraft.core.net.command.TextFormatting;
+import net.minecraft.server.MinecraftServer;
+import net.minecraft.server.entity.player.ServerPlayer;
+
+import java.util.ArrayList;
+import java.util.List;
+
+public class ScoreboardCommand extends ServerCommand {
+    public ScoreboardCommand(MinecraftServer server) {
+        super(server, "scoreboard");
+    }
+
+    @Override
+    public boolean execute(CommandHandler handler, CommandSender sender, String[] args) {
+        StringBuilder scoreBoardMessage = new StringBuilder();
+        List<ServerPlayer> players = new ArrayList<>(server.playerList.playerEntities);
+
+        players.sort((o1, o2) -> o2.score - o1.score);
+
+        for (int i = 0; i < players.size(); i++)
+        {
+            if (i > 0)
+            {
+                scoreBoardMessage.append(", ");
+            }
+            ServerPlayer player = players.get(i);
+            scoreBoardMessage.append(player.getDisplayName()).append(": ").append(TextFormatting.YELLOW).append(player.score).append("pts").append(TextFormatting.WHITE);
+        }
+        sender.sendMessage(scoreBoardMessage.toString());
+        return true;
+    }
+
+    @Override
+    public boolean opRequired(String[] args) {
+        return false;
+    }
+
+    @Override
+    public void sendCommandSyntax(CommandHandler handler, CommandSender sender) {
+        sender.sendMessage("/scoreboard");
+    }
+}
diff --git a/src/main/java/net/minecraft/core/net/command/commands/StopCommand.java b/src/main/java/net/minecraft/core/net/command/servercommands/StopCommand.java
similarity index 94%
rename from src/main/java/net/minecraft/core/net/command/commands/StopCommand.java
rename to src/main/java/net/minecraft/core/net/command/servercommands/StopCommand.java
index 07029ad93..b951f4f16 100644
--- a/src/main/java/net/minecraft/core/net/command/commands/StopCommand.java
+++ b/src/main/java/net/minecraft/core/net/command/servercommands/StopCommand.java
@@ -1,4 +1,4 @@
-package net.minecraft.core.net.command.commands;
+package net.minecraft.core.net.command.servercommands;
 
 import net.minecraft.server.MinecraftServer;
 import net.minecraft.core.net.command.CommandHandler;
diff --git a/src/main/java/net/minecraft/core/net/command/servercommands/WhitelistCommand.java b/src/main/java/net/minecraft/core/net/command/servercommands/WhitelistCommand.java
new file mode 100644
index 000000000..004979ab6
--- /dev/null
+++ b/src/main/java/net/minecraft/core/net/command/servercommands/WhitelistCommand.java
@@ -0,0 +1,80 @@
+package net.minecraft.core.net.command.servercommands;
+
+import net.minecraft.core.net.command.CommandHandler;
+import net.minecraft.core.net.command.CommandSender;
+import net.minecraft.core.net.command.ServerCommand;
+import net.minecraft.server.MinecraftServer;
+
+import java.util.Set;
+
+public class WhitelistCommand extends ServerCommand {
+    public WhitelistCommand(MinecraftServer server) {
+        super(server, "whitelist");
+    }
+
+    @Override
+    public boolean execute(CommandHandler handler, CommandSender sender, String[] args) {
+        String senderName = sender.getName();
+        if(args.length < 1)
+        {
+            return false;
+        }
+        String subCommand = args[0].toLowerCase();
+
+        switch (subCommand){
+            case "on":
+                sendNoticeToOps(senderName, "Turned on white-listing");
+                server.propertyManager.setProperty("white-list", true);
+                return true;
+            case "off":
+                sendNoticeToOps(senderName, "Turned off white-listing");
+                server.propertyManager.setProperty("white-list", false);
+                return true;
+            case "list":
+                Set<String> set = server.playerList.getWhitelist();
+                StringBuilder builder = new StringBuilder();
+                for (String s6 : set) {
+                    builder.append("\"").append(s6).append("\"").append(", ");
+                }
+
+                String message = builder.toString();
+                if (message.endsWith(", ")){
+                    message = message.substring(0, message.length()-2);
+                }
+
+                sender.sendMessage("White-listed players: " + message);
+                return true;
+            case "add":
+                if (args.length != 2) return false;
+                String nameToAdd = args[1].toLowerCase();
+                server.playerList.addToWhiteList(nameToAdd);
+                sendNoticeToOps(senderName, "Added " + nameToAdd + " to white-list");
+                return true;
+            case "remove":
+                if (args.length != 2) return false;
+                String nameToRemove = args[1].toLowerCase();
+                server.playerList.removeFromWhiteList(nameToRemove);
+                sendNoticeToOps(senderName, "Removed " + nameToRemove + " from white-list");
+                return true;
+            case "reload":
+                server.playerList.reloadWhiteList();
+                sendNoticeToOps(senderName, "Reloaded white-list from file");
+                return true;
+        }
+        return false;
+    }
+    @Override
+    public boolean opRequired(String[] args) {
+        return true;
+    }
+
+    @Override
+    public void sendCommandSyntax(CommandHandler handler, CommandSender sender) {
+        sender.sendMessage("/whitelist on");
+        sender.sendMessage("/whitelist off");
+        sender.sendMessage("/whitelist list");
+        sender.sendMessage("/whitelist add <player>");
+        sender.sendMessage("/whitelist remove <player>");
+        sender.sendMessage("/whitelist reload");
+    }
+}
diff --git a/src/main/java/net/minecraft/core/net/command/commands/WhoisCommand.java b/src/main/java/net/minecraft/core/net/command/servercommands/WhoisCommand.java
similarity index 89%
rename from src/main/java/net/minecraft/core/net/command/commands/WhoisCommand.java
rename to src/main/java/net/minecraft/core/net/command/servercommands/WhoisCommand.java
index 3414e48af..57e6cc5ce 100644
--- a/src/main/java/net/minecraft/core/net/command/commands/WhoisCommand.java
+++ b/src/main/java/net/minecraft/core/net/command/servercommands/WhoisCommand.java
@@ -1,7 +1,7 @@
-package net.minecraft.core.net.command.commands;
+package net.minecraft.core.net.command.servercommands;
 
 import net.minecraft.server.MinecraftServer;
-import net.minecraft.server.entity.player.EntityPlayerMP;
+import net.minecraft.server.entity.player.ServerPlayer;
 import net.minecraft.core.net.command.TextFormatting;
 import net.minecraft.core.net.command.CommandHandler;
 import net.minecraft.core.net.command.CommandSender;
@@ -24,7 +24,7 @@ public class WhoisCommand extends ServerCommand {
         String enteredNickname = enteredNicknameStr.substring(0, enteredNicknameStr.length() - 1);
         if (enteredNickname.length() > 16) enteredNickname = enteredNickname.substring(0, 16);
 
-        for (EntityPlayerMP player : server.playerList.playerEntities)
+        for (ServerPlayer player : server.playerList.playerEntities)
         {
             String name = TextFormatting.removeAllFormatting(player.getDisplayName());
             if (name.equals(enteredNickname))
diff --git a/src/main/java/net/minecraft/core/net/entity/IVehicleEntry.java b/src/main/java/net/minecraft/core/net/entity/IVehicleEntry.java
index ca2eca917..f2aa675a9 100644
--- a/src/main/java/net/minecraft/core/net/entity/IVehicleEntry.java
+++ b/src/main/java/net/minecraft/core/net/entity/IVehicleEntry.java
@@ -1,11 +1,11 @@
 package net.minecraft.core.net.entity;
 
 import net.minecraft.core.entity.Entity;
-import net.minecraft.core.net.packet.Packet23VehicleSpawn;
+import net.minecraft.core.net.packet.AddEntityPacket;
 import net.minecraft.core.world.World;
 import net.minecraft.server.entity.EntityTrackerEntry;
 
 public interface IVehicleEntry<T> extends IPacketEntry<T> {
     Entity getEntity(World world, double x, double y, double z, int metadata, boolean hasVelocity, double xd, double yd, double zd, Entity owner);
-    Packet23VehicleSpawn getSpawnPacket(EntityTrackerEntry tracker, T trackedObject);
+    AddEntityPacket getSpawnPacket(EntityTrackerEntry tracker, T trackedObject);
 }
diff --git a/src/main/java/net/minecraft/core/net/entity/NetEntityHandler.java b/src/main/java/net/minecraft/core/net/entity/NetEntityHandler.java
index 1f32af28f..63ea1ec02 100644
--- a/src/main/java/net/minecraft/core/net/entity/NetEntityHandler.java
+++ b/src/main/java/net/minecraft/core/net/entity/NetEntityHandler.java
@@ -18,7 +18,6 @@ import net.minecraft.core.net.entity.entries.SnowballNetEntry;
 import net.minecraft.core.net.entity.entries.SquidNetEntry;
 import net.minecraft.core.net.entity.entries.TNTNetEntry;
 import net.minecraft.core.net.packet.Packet;
-import net.minecraft.core.net.packet.Packet23VehicleSpawn;
 import net.minecraft.server.entity.EntityTrackerEntry;
 import org.jetbrains.annotations.NotNull;
 
diff --git a/src/main/java/net/minecraft/core/net/entity/entries/AnimalNetEntry.java b/src/main/java/net/minecraft/core/net/entity/entries/AnimalNetEntry.java
index c512115ad..93dc18279 100644
--- a/src/main/java/net/minecraft/core/net/entity/entries/AnimalNetEntry.java
+++ b/src/main/java/net/minecraft/core/net/entity/entries/AnimalNetEntry.java
@@ -1,19 +1,19 @@
 package net.minecraft.core.net.entity.entries;
 
-import net.minecraft.core.entity.EntityLiving;
-import net.minecraft.core.entity.animal.IAnimal;
+import net.minecraft.core.entity.Mob;
+import net.minecraft.core.entity.animal.Creature;
 import net.minecraft.core.net.entity.IPacketEntry;
 import net.minecraft.core.net.entity.ITrackedEntry;
 import net.minecraft.core.net.packet.Packet;
-import net.minecraft.core.net.packet.Packet24MobSpawn;
+import net.minecraft.core.net.packet.AddMobPacket;
 import net.minecraft.server.entity.EntityTracker;
 import net.minecraft.server.entity.EntityTrackerEntry;
 import org.jetbrains.annotations.NotNull;
 
-public class AnimalNetEntry<T extends IAnimal> implements IPacketEntry<T>, ITrackedEntry<T> {
+public class AnimalNetEntry<T extends Creature> implements IPacketEntry<T>, ITrackedEntry<T> {
     @Override
     public @NotNull Class<T> getAppliedClass() {
-        return (Class<T>) IAnimal.class;
+        return (Class<T>) Creature.class;
     }
 
     @Override
@@ -32,12 +32,12 @@ public class AnimalNetEntry<T extends IAnimal> implements IPacketEntry<T>, ITrac
     }
 
     @Override
-    public void onEntityTracked(EntityTracker tracker, EntityTrackerEntry trackerEntry, IAnimal trackedObject) {
+    public void onEntityTracked(EntityTracker tracker, EntityTrackerEntry trackerEntry, Creature trackedObject) {
 
     }
 
     @Override
-    public Packet getSpawnPacket(EntityTrackerEntry tracker, IAnimal trackedObject) {
-        return new Packet24MobSpawn((EntityLiving) trackedObject);
+    public Packet getSpawnPacket(EntityTrackerEntry tracker, Creature trackedObject) {
+        return new AddMobPacket((Mob) trackedObject);
     }
 }
diff --git a/src/main/java/net/minecraft/core/net/entity/entries/ArrowNetEntry.java b/src/main/java/net/minecraft/core/net/entity/entries/ArrowNetEntry.java
index 2e025486c..86ebf4325 100644
--- a/src/main/java/net/minecraft/core/net/entity/entries/ArrowNetEntry.java
+++ b/src/main/java/net/minecraft/core/net/entity/entries/ArrowNetEntry.java
@@ -1,23 +1,22 @@
 package net.minecraft.core.net.entity.entries;
 
 import net.minecraft.core.entity.Entity;
-import net.minecraft.core.entity.EntityLiving;
-import net.minecraft.core.entity.projectile.EntityArrow;
-import net.minecraft.core.entity.projectile.EntityArrowGolden;
-import net.minecraft.core.entity.projectile.EntityArrowPurple;
+import net.minecraft.core.entity.Mob;
+import net.minecraft.core.entity.projectile.ArrowProjectile;
+import net.minecraft.core.entity.projectile.ArrowProjectileGolden;
+import net.minecraft.core.entity.projectile.ArrowProjectilePurple;
 import net.minecraft.core.net.entity.ITrackedEntry;
 import net.minecraft.core.net.entity.IVehicleEntry;
-import net.minecraft.core.net.packet.Packet;
-import net.minecraft.core.net.packet.Packet23VehicleSpawn;
+import net.minecraft.core.net.packet.AddEntityPacket;
 import net.minecraft.core.world.World;
 import net.minecraft.server.entity.EntityTracker;
 import net.minecraft.server.entity.EntityTrackerEntry;
 import org.jetbrains.annotations.NotNull;
 
-public class ArrowNetEntry implements IVehicleEntry<EntityArrow>, ITrackedEntry<EntityArrow> {
+public class ArrowNetEntry implements IVehicleEntry<ArrowProjectile>, ITrackedEntry<ArrowProjectile> {
     @Override
-    public @NotNull Class<EntityArrow> getAppliedClass() {
-        return EntityArrow.class;
+    public @NotNull Class<ArrowProjectile> getAppliedClass() {
+        return ArrowProjectile.class;
     }
 
     @Override
@@ -36,25 +35,25 @@ public class ArrowNetEntry implements IVehicleEntry<EntityArrow>, ITrackedEntry<
     }
 
     @Override
-    public void onEntityTracked(EntityTracker tracker, EntityTrackerEntry trackerEntry, EntityArrow trackedObject) {
+    public void onEntityTracked(EntityTracker tracker, EntityTrackerEntry trackerEntry, ArrowProjectile trackedObject) {
 
     }
 
     @Override
     public Entity getEntity(World world, double x, double y, double z, int metadata, boolean hasVelocity, double xd, double yd, double zd, Entity owner) {
         if (metadata == 2) {
-            return new EntityArrowGolden(world, x, y, z);
+            return new ArrowProjectileGolden(world, x, y, z);
         } else if (metadata == 1) {
-            return new EntityArrowPurple(world, x, y, z);
+            return new ArrowProjectilePurple(world, x, y, z);
         } else {
-            return new EntityArrow(world, x, y, z, metadata);
+            return new ArrowProjectile(world, x, y, z, metadata);
         }
     }
 
     @Override
-    public Packet23VehicleSpawn getSpawnPacket(EntityTrackerEntry tracker, EntityArrow trackedObject) {
-        EntityLiving entityliving = trackedObject.owner;
-        return new Packet23VehicleSpawn(trackedObject,
+    public AddEntityPacket getSpawnPacket(EntityTrackerEntry tracker, ArrowProjectile trackedObject) {
+        Mob entityliving = trackedObject.owner;
+        return new AddEntityPacket(trackedObject,
             trackedObject.getArrowType(), entityliving == null ? -1 : entityliving.id,
             trackedObject.xd, trackedObject.yd, trackedObject.zd);
     }
diff --git a/src/main/java/net/minecraft/core/net/entity/entries/BoatNetEntry.java b/src/main/java/net/minecraft/core/net/entity/entries/BoatNetEntry.java
index 5dae1d34e..2adf2535c 100644
--- a/src/main/java/net/minecraft/core/net/entity/entries/BoatNetEntry.java
+++ b/src/main/java/net/minecraft/core/net/entity/entries/BoatNetEntry.java
@@ -1,20 +1,19 @@
 package net.minecraft.core.net.entity.entries;
 
 import net.minecraft.core.entity.Entity;
-import net.minecraft.core.entity.vehicle.EntityBoat;
+import net.minecraft.core.entity.vehicle.BoatEntity;
 import net.minecraft.core.net.entity.ITrackedEntry;
 import net.minecraft.core.net.entity.IVehicleEntry;
-import net.minecraft.core.net.packet.Packet;
-import net.minecraft.core.net.packet.Packet23VehicleSpawn;
+import net.minecraft.core.net.packet.AddEntityPacket;
 import net.minecraft.core.world.World;
 import net.minecraft.server.entity.EntityTracker;
 import net.minecraft.server.entity.EntityTrackerEntry;
 import org.jetbrains.annotations.NotNull;
 
-public class BoatNetEntry implements IVehicleEntry<EntityBoat>, ITrackedEntry<EntityBoat> {
+public class BoatNetEntry implements IVehicleEntry<BoatEntity>, ITrackedEntry<BoatEntity> {
     @Override
-    public @NotNull Class<EntityBoat> getAppliedClass() {
-        return EntityBoat.class;
+    public @NotNull Class<BoatEntity> getAppliedClass() {
+        return BoatEntity.class;
     }
 
     @Override
@@ -33,17 +32,17 @@ public class BoatNetEntry implements IVehicleEntry<EntityBoat>, ITrackedEntry<En
     }
 
     @Override
-    public void onEntityTracked(EntityTracker tracker, EntityTrackerEntry trackerEntry, EntityBoat trackedObject) {
+    public void onEntityTracked(EntityTracker tracker, EntityTrackerEntry trackerEntry, BoatEntity trackedObject) {
 
     }
 
     @Override
     public Entity getEntity(World world, double x, double y, double z, int metadata, boolean hasVelocity, double xd, double yd, double zd, Entity owner) {
-        return new EntityBoat(world, x, y, z);
+        return new BoatEntity(world, x, y, z);
     }
 
     @Override
-    public Packet23VehicleSpawn getSpawnPacket(EntityTrackerEntry tracker, EntityBoat trackedObject) {
-        return new Packet23VehicleSpawn(trackedObject);
+    public AddEntityPacket getSpawnPacket(EntityTrackerEntry tracker, BoatEntity trackedObject) {
+        return new AddEntityPacket(trackedObject);
     }
 }
diff --git a/src/main/java/net/minecraft/core/net/entity/entries/BobberEntry.java b/src/main/java/net/minecraft/core/net/entity/entries/BobberEntry.java
index 77cce06c3..7ed14118a 100644
--- a/src/main/java/net/minecraft/core/net/entity/entries/BobberEntry.java
+++ b/src/main/java/net/minecraft/core/net/entity/entries/BobberEntry.java
@@ -1,20 +1,19 @@
 package net.minecraft.core.net.entity.entries;
 
 import net.minecraft.core.entity.Entity;
-import net.minecraft.core.entity.EntityBobber;
+import net.minecraft.core.entity.FishingBobberEntity;
 import net.minecraft.core.net.entity.ITrackedEntry;
 import net.minecraft.core.net.entity.IVehicleEntry;
-import net.minecraft.core.net.packet.Packet;
-import net.minecraft.core.net.packet.Packet23VehicleSpawn;
+import net.minecraft.core.net.packet.AddEntityPacket;
 import net.minecraft.core.world.World;
 import net.minecraft.server.entity.EntityTracker;
 import net.minecraft.server.entity.EntityTrackerEntry;
 import org.jetbrains.annotations.NotNull;
 
-public class BobberEntry implements IVehicleEntry<EntityBobber>, ITrackedEntry<EntityBobber> {
+public class BobberEntry implements IVehicleEntry<FishingBobberEntity>, ITrackedEntry<FishingBobberEntity> {
     @Override
-    public @NotNull Class<EntityBobber> getAppliedClass() {
-        return EntityBobber.class;
+    public @NotNull Class<FishingBobberEntity> getAppliedClass() {
+        return FishingBobberEntity.class;
     }
 
     @Override
@@ -33,17 +32,17 @@ public class BobberEntry implements IVehicleEntry<EntityBobber>, ITrackedEntry<E
     }
 
     @Override
-    public void onEntityTracked(EntityTracker tracker, EntityTrackerEntry trackerEntry, EntityBobber trackedObject) {
+    public void onEntityTracked(EntityTracker tracker, EntityTrackerEntry trackerEntry, FishingBobberEntity trackedObject) {
 
     }
 
     @Override
     public Entity getEntity(World world, double x, double y, double z, int metadata, boolean hasVelocity, double xd, double yd, double zd, Entity owner) {
-        return new EntityBobber(world, x, y, z);
+        return new FishingBobberEntity(world, x, y, z);
     }
 
     @Override
-    public Packet23VehicleSpawn getSpawnPacket(EntityTrackerEntry tracker, EntityBobber trackedObject) {
-        return new Packet23VehicleSpawn(trackedObject);
+    public AddEntityPacket getSpawnPacket(EntityTrackerEntry tracker, FishingBobberEntity trackedObject) {
+        return new AddEntityPacket(trackedObject);
     }
 }
diff --git a/src/main/java/net/minecraft/core/net/entity/entries/CannonballEntry.java b/src/main/java/net/minecraft/core/net/entity/entries/CannonballEntry.java
index b6c80012b..605d42e09 100644
--- a/src/main/java/net/minecraft/core/net/entity/entries/CannonballEntry.java
+++ b/src/main/java/net/minecraft/core/net/entity/entries/CannonballEntry.java
@@ -1,21 +1,20 @@
 package net.minecraft.core.net.entity.entries;
 
 import net.minecraft.core.entity.Entity;
-import net.minecraft.core.entity.EntityLiving;
-import net.minecraft.core.entity.projectile.EntityCannonball;
+import net.minecraft.core.entity.Mob;
+import net.minecraft.core.entity.projectile.CannonballProjectile;
 import net.minecraft.core.net.entity.ITrackedEntry;
 import net.minecraft.core.net.entity.IVehicleEntry;
-import net.minecraft.core.net.packet.Packet;
-import net.minecraft.core.net.packet.Packet23VehicleSpawn;
+import net.minecraft.core.net.packet.AddEntityPacket;
 import net.minecraft.core.world.World;
 import net.minecraft.server.entity.EntityTracker;
 import net.minecraft.server.entity.EntityTrackerEntry;
 import org.jetbrains.annotations.NotNull;
 
-public class CannonballEntry implements IVehicleEntry<EntityCannonball>, ITrackedEntry<EntityCannonball> {
+public class CannonballEntry implements IVehicleEntry<CannonballProjectile>, ITrackedEntry<CannonballProjectile> {
     @Override
-    public @NotNull Class<EntityCannonball> getAppliedClass() {
-        return EntityCannonball.class;
+    public @NotNull Class<CannonballProjectile> getAppliedClass() {
+        return CannonballProjectile.class;
     }
 
     @Override
@@ -34,19 +33,19 @@ public class CannonballEntry implements IVehicleEntry<EntityCannonball>, ITracke
     }
 
     @Override
-    public void onEntityTracked(EntityTracker tracker, EntityTrackerEntry trackerEntry, EntityCannonball trackedObject) {
+    public void onEntityTracked(EntityTracker tracker, EntityTrackerEntry trackerEntry, CannonballProjectile trackedObject) {
 
     }
 
     @Override
     public Entity getEntity(World world, double x, double y, double z, int metadata, boolean hasVelocity, double xd, double yd, double zd, Entity owner) {
-        return new EntityCannonball(world, x, y, z);
+        return new CannonballProjectile(world, x, y, z);
     }
 
     @Override
-    public Packet23VehicleSpawn getSpawnPacket(EntityTrackerEntry tracker, EntityCannonball trackedObject) {
-        EntityLiving entityliving = trackedObject.owner;
-        return new Packet23VehicleSpawn(trackedObject, -1,
+    public AddEntityPacket getSpawnPacket(EntityTrackerEntry tracker, CannonballProjectile trackedObject) {
+        Mob entityliving = trackedObject.owner;
+        return new AddEntityPacket(trackedObject, -1,
             entityliving == null ? -1 : entityliving.id,
             trackedObject.xd, trackedObject.yd, trackedObject.zd);
     }
